/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * 確認ダイアログ
 */
var UnMHTConfirm = {
  result : null,       /* Object  結果オブジェクト */
  base : "",           /* String  ファイルのベースディレクトリ */
  dialog : null,       /* XULElement  ダイアログ */
  existsMessage1 : "", /* String  ファイルが存在した場合のメッセージ */
  existsMessage2 : "", /* String  ファイルが存在した場合のメッセージ */
  useFile : false,     /* Boolean  ファイルを使用するか */
    
  /**
   * 初期化処理
   */
  init : function () {
    var arg = window.arguments [0];
    
    UnMHTConfirm.useFile = true;
    if ("filename" in arg) {
      UnMHTConfirm.useFile = false;
    }
        
    UnMHTConfirm.result = arg.result;
    if ("base" in arg) {
      UnMHTConfirm.base = arg.base;
    }
    if ("exist1" in arg) {
      UnMHTConfirm.existsMessage1 = arg.exist1;
    }
    if ("exist2" in arg) {
      UnMHTConfirm.existsMessage2 = arg.exist2;
    }
    
    var button;
    
    UnMHTConfirm.dialog = document.getElementById ("unmht_confirm");
    UnMHTConfirm.dialog.setAttribute ("title", arg.title);

    var title = document.getElementById ("title");
    title.setAttribute ("value", arg.title);
        
    button = UnMHTConfirm.dialog.getButton ("accept");
    button.setAttribute ("label", arg.accept);
    button = UnMHTConfirm.dialog.getButton ("cancel");
    if ("cancel" in arg) {
      button.setAttribute ("label", arg.cancel);
    }
    else {
      button.hidden = true;
    }
        
    button = UnMHTConfirm.dialog.getButton ("extra2");
    if ("extra2" in arg) {
      button.setAttribute ("label", arg.extra2);
      button.addEventListener
        ("command",
         function () {
          UnMHTConfirm.onClick ("abort");
        }, true);
    }
    else {
      button.hidden = true;
    }
    button = UnMHTConfirm.dialog.getButton ("extra1");
    if ("extra1" in arg) {
      button.setAttribute ("label", arg.extra1);
      button.addEventListener
        ("command",
         function () {
          UnMHTConfirm.onClick ("skip");
        }, true);
    }
    else {
      button.hidden = true;
    }
        
    document.getElementById ("message1").value = arg.message1;
    if ("message2" in arg
        && arg.message2) {
      document.getElementById ("message2").value = arg.message2;
    }
    else {
      document.getElementById ("message2").hidden = true;
    }
    if ("message3" in arg
        && arg.message3) {
      document.getElementById ("message3").value = arg.message3;
    }
    else {
      document.getElementById ("message3").hidden = true;
    }

    if ("toall" in arg
        && arg.toall) {
      document.getElementById ("apply_to_all").checked = false;
      document.getElementById ("apply_to_all").label = arg.toall;
    }
    else {
      document.getElementById ("apply_to_all").hidden = true;
    }
        
    if ("rename" in arg) {
      document.getElementById ("rename").label = arg.rename;
      document.getElementById ("filename").value = arg.filename;
    }
    else {
      document.getElementById ("renamebox").hidden = true;
    }
  },
    
  /**
   * すべてに適用ボタンを押したイベント
   */
  onCheckApplyToAll : function () {
    if (UnMHTConfirm.useFile) {
      UnMHTConfirm.dialog.getButton ("cancel").disabled = false;
    }
  },
    
  /**
   * ボタンを押したイベント
   */
  onClick : function (type) {
    document.getElementById ("rename_exists").value = "";
    document.getElementById ("rename_exists").hidden = true;
        
    if (type == "rename") {
      var file
        = Components.classes ["@mozilla.org/file/local;1"]
        .createInstance (Components.interfaces.nsILocalFile);
      try {
        file.initWithPath (UnMHTConfirm.base);
      }
      catch (e) {
        return false;
      }
      var filename = document.getElementById ("filename").value;
      file.appendRelativePath (filename);
        
      if (file.exists ()) {
        document.getElementById ("rename_exists").value
          = UnMHTConfirm.existsMessage1
          + " " + filename + " " + UnMHTConfirm.existsMessage2;
        document.getElementById ("rename_exists").hidden = false;
        document.getElementById ("filename").focus ();
          
        return false;
      }
      UnMHTConfirm.result.rename = true;
    }
    else {
      UnMHTConfirm.result.rename = false;
    }
    
    UnMHTConfirm.result.result = type;
    UnMHTConfirm.result.applyToAll
    = document.getElementById ("apply_to_all").checked;
    UnMHTConfirm.result.filename
    = document.getElementById ("filename").value;
    if (type == "abort" || type == "skip" || type == "rename") {
      window.close ();
    }
        
    return true;
  }
};
