/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * メール送信
 */
var UnMHTMail = {
  thunderbird : "-remote \"xfeDoCommand(composeMessage,subject=\'%TITLE%\',attachment=\'%URI%\')\"",
  outlook : "",
  winmail : "",
  
  /**
   * スペース区切りの引数を引数配列に変換する
   *
   * @param  String arg
   *         スペース区切りの引数
   * @return Array
   *         引数配列
   */
  argToArray : function (arg) {
    var a = [];
    var v = "";
    var state = 0;
    
    for (var i = 0; i < arg.length; i ++) {
      var c = arg.substr (i, 1);
      
      if (state == 0) {
        if (c == "\\") {
          state = 1;
          continue;
        }
        if (v == ""
            && c == "\"") {
          state = 10;
          continue;
        }
        if (v == ""
            && c == "\'") {
          state = 20;
          continue;
        }
        if (c == " ") {
          if (v != "") {
            a.push (v);
          }
          v = "";
          continue;
        }
        v += c;
        continue;
      }
      else if (state == 1) {
        v += c;
        state = 0;
        continue;
      }
      else if (state == 10) {
        if (c == "\"") {
          state = 0;
          continue;
        }
        if (c == "\\") {
          state = 11;
          continue;
        }
        v += c;
        continue;
      }
      else if (state == 11) {
        v += c;
        state = 10;
        continue;
      }
      else if (state == 20) {
        if (c == "\'") {
          state = 0;
          continue;
        }
        if (c == "\\") {
          state = 21;
          continue;
        }
        v += c;
        continue;
      }
      else if (state == 21) {
        v += c;
        state = 20;
        continue;
      }
    }
    if (v != "") {
      a.push (v);
    }
    
    return a;
  },
  
  /**
   * メール送信アプリケーションを起動する
   *
   * @param  String app
   *         メール送信アプリケーション
   * @param  String arg
   *         スペース区切りの引数
   * @param  String targetPath
   *         添付ファイルのフルパス
   * @param  String targetURI
   *         添付ファイルの URI
   * @param  String title
   *         ページのタイトル
   */
  launch : function (app, arg, targetPath, targetURI, title) {
    if (app == "") {
      var list = [
        "/Applications/Thunderbird.app/Contents/MacOS/thunderbird-bin",
        "C:\\Program Files\\Mozilla Thunderbird\\thunderbird.exe",
        "C:\\Program Files\\thunderbird\\thunderbird.exe"
        ];
      arg = UnMHTMail.thunderbird;
      for (var i = 0; i < list.length; i ++) {
        try {
          var file
            = Components.classes ["@mozilla.org/file/local;1"]
            .createInstance (Components.interfaces.nsILocalFile);
          file.initWithPath (list [i]);
          if (file.exists ()) {
            app = list [i];
            break;
          }
        }
        catch (e) {
        }
      }
      if (app == "") {
        alert (UnMHT.messages.GetStringFromName ("sendmail_fail")+ "\n"
               + UnMHT.messages.GetStringFromName ("sendmail_fail2"));
        return;
      }
    }
    
    arg = arg.replace (/%FILE%/g, targetPath.replace (/\\/g, "\\\\"));
    arg = arg.replace (/%URI%/g, targetURI.replace (/\\/g, "\\\\"));
    arg = arg.replace (/%TITLE%/g, title.replace (/\\/g, "\\\\"));
    
    try {
      var file
        = Components.classes ["@mozilla.org/file/local;1"]
        .createInstance (Components.interfaces.nsILocalFile);
      file.initWithPath (app);
      if (file.isDirectory ()
          && app.match (/\.app$/)) {
        file
          = Components.classes ["@mozilla.org/file/local;1"]
          .createInstance (Components.interfaces.nsILocalFile);
        file.initWithPath (app + "/Contents/MacOS/thunderbird-bin");
      }
      
      var process
        = Components.classes ["@mozilla.org/process/util;1"]
        .createInstance (Components.interfaces.nsIProcess);
      process.init (file);
      var args = UnMHTMail.argToArray (arg);
      if (UnMHT.enableSendmailDebug) {
        alert ("[Debug]\nCommand line for mail\n\n" + file.path + " " + arg + "\n\nArguments will be passed as following array\n\n" + args.join ("\n"));
      }
      process.run (false, args, args.length);
    }
    catch (e) {
      alert (UnMHT.messages.GetStringFromName ("sendmail_fail")+ "\n"
             + UnMHT.messages.GetStringFromName ("sendmail_fail2"));
    }
  }
};
