/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * 保存ダイアログ
 */
var UnMHTSaveDialog = {
  messages : null,     /* nsIStringBundle  メッセージ */
    
  progressLabel : null,       /* XULElement  取得状況のラベル */
  progressCurrent : null,     /* XULElement  現在取得しているファイル */
  progressCurrentSize : null, /* XULElement  現在取得しているファイルの
                               *   サイズ */
  progress : null,            /* XULElement  取得状況のバー */
  failedLabel : null,         /* XULElement  失敗したファイルのラベル */
  failedLabel2 : null,        /* XULElement  失敗したファイルのラベル2 */
  failedLabel3 : null,        /* XULElement  失敗したファイルのラベル3 */
  failedList : null,          /* XULElement  失敗したファイル */
  acceptButton : null,        /* XULElement  OK ボタン */
  cancelButton : null,        /* XULElement  キャンセルボタン */
    
  enableShowErrors : false,   /* Boolean  保存されなかったファイルを
                               *   表示する */
  
  callback : null,            /* Function  終了時コールバック */
    
  saveContext : null,         /* UnMHTSaveContext  保存コンテキスト */
    
  /**
   * 初期化処理
   */
  init : function () {
    var param = window.arguments [0];
        
    UnMHTSaveDialog.messages
    = Components.classes ["@mozilla.org/intl/stringbundle;1"]
    .getService (Components.interfaces.nsIStringBundleService)
    .createBundle ("chrome://unmht/locale/unmht.properties");
        
    UnMHTSaveDialog.config = new UnMHTConfigManager ();
        
    UnMHTSaveDialog.enableShowErrors
    = UnMHTSaveDialog.config
    .initPref ("bool", "unmht.save.show_errors", true);
        
    var dialog = document.getElementById ("unmhtSaveDialog");
        
    UnMHTSaveDialog.acceptButton = dialog.getButton ("accept");
    UnMHTSaveDialog.cancelButton = dialog.getButton ("cancel");
        
    UnMHTSaveDialog.acceptButton.disabled = true;
        
    if (param.useCurrentState) {
      document.title
        = document.getElementById ("current_label").value;
    }
    else  {
      document.title
      = document.getElementById ("original_label").value;
    }
        
    UnMHTSaveDialog.progressLabel
    = document.getElementById ("progress_label");
    UnMHTSaveDialog.progressCurrent
    = document.getElementById ("progress_current");
    UnMHTSaveDialog.progressCurrentSize
    = document.getElementById ("progress_current_size");
    UnMHTSaveDialog.progress
    = document.getElementById ("progress");
    UnMHTSaveDialog.failedLabel
    = document.getElementById ("failed_label");
    UnMHTSaveDialog.failedLabel2
    = document.getElementById ("failed_label2");
    UnMHTSaveDialog.failedLabel3
    = document.getElementById ("failed_label3");
    UnMHTSaveDialog.failedList
    = document.getElementById ("failed");
        
    UnMHTSaveDialog.progressLabel.value
    = UnMHTSaveDialog.messages.GetStringFromName ("save_begin");
    UnMHTSaveDialog.progress.setAttribute ("value", "0%");
        
    var subject;
    if (param.isScrapBook) {
      subject = param.scrapBookData ["title"];
    }
    else {
      subject = param.targetDocument.title;
    }
    
    UnMHTSaveDialog.callback = param.callback;
        
    UnMHTSave.init ();
    
    UnMHTSaveDialog.saveContext = new UnMHTSaveContext ();
    
    UnMHTSaveDialog.saveContext.init
    (param.targetFile,
     param.targetDocument.location.href, subject, UnMHTSaveDialog);
        
    UnMHTSaveDialog.saveContext.addDocument
    (param.targetDocument, param.useCurrentState,
     param.isScrapBook, param.scrapBookData,
     param.targetSelection,
     param.targetDocument.location.href, true, true);
    if (UnMHTSaveDialog.saveContext.isStopped) {
      UnMHTSaveDialog.saveContext = null;
      return;
    }
    else {
      if (param.additionalFiles) {
        for (var i = 0; i < param.additionalFiles.length; i ++) {
          UnMHTSaveDialog.saveContext.addFile (null, param.additionalFiles [i]);
        }
      }
    }
    
    UnMHTSaveDialog.saveContext.start ();
  },
    
  /**
   * 保存失敗イベント
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  String type
   *         エラーの種類
   * @param  String desc
   *         エラーの詳細
   */
  onError : function (context, type, desc) {
    if (type == "save") {
      UnMHTSaveDialog.progressLabel.value
      = UnMHTSaveDialog.messages.GetStringFromName ("error_save");
    }
    else if (type == "open") {
      UnMHTSaveDialog.progressLabel.value
      = UnMHTSaveDialog.messages.GetStringFromName ("error_open");
    }
    else {
      UnMHTSaveDialog.progressCurrent.value = desc;
    }
  },

  /**
   * 進行状況変化イベント
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  String currentFile
   *         現在取得のファイル名
   * @param  Number currentSize
   *         取得したバイト数
   * @param  Number ok
   *         取得完了した数
   * @param  Number na
   *         取得中の数
   * @param  Number ng
   *         取得失敗した数
   */
  onProgress : function (context, currentFile, currentSize, ok, na, ng) {
    UnMHTSaveDialog.progressCurrent.value = currentFile;
    UnMHTSaveDialog.progressCurrentSize.value = currentSize;
        
    if (na > 0) {
      UnMHTSaveDialog.progressLabel.value
        = UnMHTSaveDialog.messages.GetStringFromName ("save_begin")
        + " " + (ok + ng) + "/" + (context.files.length);
      UnMHTSaveDialog.progress.setAttribute
        ("value",
         parseInt (ok * 100 / context.files.length) + "%");
    }
    else {
      UnMHTSaveDialog.progressLabel.value
      = UnMHTSaveDialog.messages.GetStringFromName ("save_begin")
      + " " + (ok + ng) + "/" + (context.files.length);
      UnMHTSaveDialog.progress.setAttribute ("value", "100%");
    }
  },
    
  /**
   * 保存完了
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  Array ngList
   *         失敗したファイル
   *           [String ファイル名, ...]
   */
  onSave : function (context, ngList) {
    UnMHTSaveDialog.progressLabel.value
    = UnMHTSaveDialog.messages.GetStringFromName ("save_done");
        
    if (UnMHTSaveDialog.enableShowErrors && ngList.length > 0) {
      UnMHTSaveDialog.acceptButton.disabled = false;
      UnMHTSaveDialog.cancelButton.disabled = true;
      var s = "";
      for (var i = 0; i < ngList.length; i ++) {
        s += ngList [i] + "\n";
      }
      UnMHTSaveDialog.failedList.value = s;
      UnMHTSaveDialog.failedList.hidden = false;
      if (UnMHTSaveDialog.failedLabel
          && UnMHTSaveDialog.failedLabel.value != "") {
        UnMHTSaveDialog.failedLabel.hidden = false;
      }
      if (UnMHTSaveDialog.failedLabel2
          && UnMHTSaveDialog.failedLabel2.value != "") {
        UnMHTSaveDialog.failedLabel2.hidden = false;
      }
      if (UnMHTSaveDialog.failedLabel3
          && UnMHTSaveDialog.failedLabel3.value != "") {
        UnMHTSaveDialog.failedLabel3.hidden = false;
      }
      window.sizeToContent ();
    }
    else {
      setTimeout (function (window) {
          if (UnMHTSaveDialog.callback) {
            UnMHTSaveDialog.callback (false);
          }
          window.close ();
        }, 1000, window);
    }
  },
  
  /**
   * キャンセルが完了したイベント
   */
  onCancel : function () {
    if (UnMHTSaveDialog.callback) {
      UnMHTSaveDialog.callback (true);
    }
    window.close ();
  },
    
  /**
   * OK ボタンのイベント
   */
  accept : function () {
    if (UnMHTSaveDialog.callback) {
      UnMHTSaveDialog.callback (false);
    }
        
    return true;
  },
  
  /**
   * キャンセルボタンのイベント
   */
  cancel : function () {
    if (!UnMHTSaveDialog.saveContext) {
      return true;
    }
    if (UnMHTSaveDialog.saveContext.isStopped) {
      /* 保存が停止していればダイアログを閉じる */
      
      if (UnMHTSaveDialog.callback) {
        UnMHTSaveDialog.callback (true);
      }
      return true;
    }
    
    UnMHTSaveDialog.saveContext.cancel ();
    UnMHTSaveDialog.saveContext = null;
    
    return false;
  },
    
  /**
   * 保存の停止
   */
  stop : function () {
    if (UnMHTSaveDialog.callback) {
      UnMHTSaveDialog.callback (true);
    }
    window.close ();
  }
};
