/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * 保存の本体
 */
var UnMHTSaveMulti = {
  messages : null,      /* nsIStringBundle  メッセージ */
  targetWindow : null,  /* nsIWindow  現在のウィンドウ */
  saveFilename : "",    /* String  保存時のファイル名 */
    
  targetDocuments : null, /* Array  対象のドキュメント */
  currentIndex : 0,       /* Number  現在保存中のドキュメントの位置 */
    
  defaultMode : -1,    /* Number  同名のファイルがあった場合にどうするか
                        *  -1:  未定義
                        *   0:  上書きする
                        *   1:  名前を変える */
  
  dialog : null,              /* XULElement  ダイアログ */
  acceptButton : null,        /* XULElement  OK ボタン */
  cancelButton : null,        /* XULElement  キャンセルボタン */
  skipButton : null,          /* XULElement  スキップボタン */
  progressLabel : null,       /* XULElement  取得状況のラベル */
  progressCurrent : null,     /* XULElement  現在取得しているファイル */
  progressCurrentSize : null, /* XULElement  現在取得しているファイルの
                               *   サイズ */
  progress : null,            /* XULElement  取得状況のバー */
  failedLabel : null,         /* XULElement  失敗したファイルのラベル */
  failedLabel2 : null,        /* XULElement  失敗したファイルのラベル2 */
  failedLabel3 : null,        /* XULElement  失敗したファイルのラベル3 */
  failedList : null,          /* XULElement  失敗したファイル */
  additionalBox : null,       /* XULElement  追加ファイル */
    
  saveFilenameCustom : "",    /* String  カスタムファイル名テンプレート */
  saveFilenameCustomAM : "",  /* String  カスタムファイル名テンプレート
                               *   a.m. */
  saveFilenameCustomPM : "",  /* String  カスタムファイル名テンプレート
                               *   p.m. */
    
  enableShowErrors : false,   /* Boolean  保存されなかったファイルを
                               *   表示する */
    
  enableAutoClose : false,    /* Boolean  自動でダイアログを閉じる */
  enableNone : false,         /* Boolean  デフォルトですべて解除 */
  enableAutoReplace : false,  /* Boolean  同名のファイルがあった場合に
                               *   自動的に処理する */
  autoReplaceAction : "",     /* String  上書き/名前を変えて保存 */
  
  dupDigits : 1,              /* 同名のファイルが存在した場合に
                               * ファイル名の末尾に n 桁の数字を追加する */
    
  saveContext : null,         /* UnMHTSaveContext  保存コンテキスト */
    
  config : null,              /* UnMHTConfigManager 設定管理 */
  conv : null,                /* UnMHTConverter 文字列変換器 */
    
  ngList : null,              /* Array  失敗したファイル */
  
  /**
   * 初期化処理
   */
  init : function () {
    UnMHTSaveMulti.messages
    = Components.classes ["@mozilla.org/intl/stringbundle;1"]
    .getService (Components.interfaces.nsIStringBundleService)
    .createBundle ("chrome://unmht/locale/unmht.properties");
        
    var param = window.arguments [0];
        
    UnMHTSaveMulti.targetWindow = param.targetWindow;
    UnMHTSaveMulti.saveFilename = param.saveFilename;
        
    UnMHTSaveMulti.targetDocuments = new Array ();
    UnMHTSaveMulti.currentIndex = 0;
        
    UnMHTSaveMulti.dialog
    = document.getElementById ("unmhtSaveMultiDialog"),
    UnMHTSaveMulti.acceptButton
    = UnMHTSaveMulti.dialog.getButton ("accept");
    UnMHTSaveMulti.acceptButton.setAttribute ("accesskey", "s");
    UnMHTSaveMulti.acceptButton.label
    = UnMHTSaveMulti.messages.GetStringFromName ("savemulti_save");
    UnMHTSaveMulti.cancelButton
    = UnMHTSaveMulti.dialog.getButton ("cancel");
    UnMHTSaveMulti.cancelButton.label
    = UnMHTSaveMulti.messages.GetStringFromName ("savemulti_cancel");
        
    UnMHTSaveMulti.skipButton
    = document.getElementById ("skip");
        
    UnMHTSaveMulti.progressLabel
    = document.getElementById ("progress_label");
    UnMHTSaveMulti.progressCurrent
    = document.getElementById ("progress_current");
    UnMHTSaveMulti.progressCurrentSize
    = document.getElementById ("progress_current_size");
    UnMHTSaveMulti.progress
    = document.getElementById ("progress");
    UnMHTSaveMulti.failedLabel
    = document.getElementById ("failed_label");
    UnMHTSaveMulti.failedLabel2
    = document.getElementById ("failed_label2");
    UnMHTSaveMulti.failedLabel3
    = document.getElementById ("failed_label3");
    UnMHTSaveMulti.failedList
    = document.getElementById ("failed");
    UnMHTSaveMulti.additionalBox
    = document.getElementById ("additional");
        
    UnMHTSaveMulti.progressLabel.value
    = UnMHTSaveMulti.messages.GetStringFromName ("save_begin");
    UnMHTSaveMulti.progress.setAttribute ("value", "0%");
        
    UnMHTSaveMulti.conv = new UnMHTConverter ();
        
    UnMHTSaveMulti.config = new UnMHTConfigManager ();
        
    UnMHTSave.init ();
        
    var value;
    var base;
    base
    = UnMHTSaveMulti.config
    .initPref ("char", "unmht.savemulti.base", "");
        
    value
    = UnMHTSaveMulti.config
    .initPref ("char", "unmht.save.filename.custom", "");
    UnMHTSaveMulti.saveFilenameCustom = unescape (value);
        
    value
    = UnMHTSaveMulti.config
    .initPref ("char", "unmht.save.filename.custom.am", "");
    UnMHTSaveMulti.saveFilenameCustomAM = unescape (value);
        
    value
    = UnMHTSaveMulti.config
    .initPref ("char", "unmht.save.filename.custom.pm", "");
    UnMHTSaveMulti.saveFilenameCustomPM = unescape (value);
        
    UnMHTSaveMulti.enableShowErrors
    = UnMHTSaveMulti.config
    .initPref ("bool", "unmht.save.show_errors", true);
        
    UnMHTSaveMulti.enableAutoClose
    = UnMHTSaveMulti.config
    .initPref ("bool", "unmht.save.multi.autoclose", false);
    UnMHTSaveMulti.enableAutoReplace
    = UnMHTSaveMulti.config
    .initPref ("bool", "unmht.save.multi.autoreplace", false);
    
    UnMHTSaveMulti.enableNone
    = UnMHTSaveMulti.config
    .initPref ("bool", "unmht.save.multi.none", false);
    
    value
    = UnMHTSaveMulti.config
    .initPref ("char", "unmht.save.multi.autoreplace.action", "");
    UnMHTSaveMulti.autoReplaceAction = unescape (value);

    UnMHTSaveMulti.dupDigits
    = UnMHTSaveMulti.config
    .initPref ("int", "unmht.save.dup.digits", 1);
    
    if (!base) {
      var dir
        = Components
        .classes ["@mozilla.org/file/directory_service;1"]
        .getService (Components.interfaces.nsIProperties)
        .get ("Home", Components.interfaces.nsIFile);
      base = dir.path;
    }
        
    document.getElementById ("base").value = unescape (base);
        
    document.getElementById ("target").value = "this";
    UnMHTSaveMulti.selectItem (document.getElementById ("target"));
        
    document.getElementById ("filename").value
    = UnMHTSaveMulti.saveFilename;
    UnMHTSaveMulti.selectItem (document.getElementById ("filename"));
        
    var lastFormat = "separated";
    try {
      var prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch);
            
      if (prefBranch.prefHasUserValue ("unmht.savemulti.lastformat")) {
        lastFormat
          = prefBranch.getCharPref ("unmht.savemulti.lastformat");
      }
    }
    catch (e) {
    }

    var lastType = "current";
    try {
      var prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch);
            
      if (prefBranch.prefHasUserValue ("unmht.savemulti.type")) {
        lastType = prefBranch.getCharPref ("unmht.savemulti.type");
      }
    }
    catch (e) {
    }
        
    document.getElementById ("saveformat").value = lastFormat;
    UnMHTSaveMulti.selectItem (document.getElementById ("saveformat"));
        
    document.getElementById ("savetype").value = lastType;
    UnMHTSaveMulti.selectItem (document.getElementById ("savetype"));
        
    UnMHTSaveMulti.changeFormat ();
    UnMHTSaveMulti.changeTitle ();
    UnMHTSaveMulti.changeAddFiles ();
        
    UnMHTSaveMulti.updateSingleFilename ();
  },
  
  /**
   * テキストフィールドでキーを押したイベント
   */
  onKeyPress : function (event) {
    if (event.keyCode == 13) {
      UnMHTSaveMulti.onSaveButton ();
    }
  },
    
  /**
   * キャンセルボタンのイベント
   */
  cancel : function () {
    if (UnMHTSaveMulti.saveContext) {
      UnMHTSaveMulti.saveContext.cancel ();
      UnMHTSaveMulti.saveContext = null;
      
      UnMHTSaveMulti.acceptButton.disabled = false;
      UnMHTSaveMulti.additionalBox.selectedIndex = 0;
      
      return false;
    }
    
    return true;
  },
    
  /**
   * 保存ボタンのイベント
   */
  onSaveButton : function () {
    document.getElementById ("saved_label").value
    = UnMHTSaveMulti.messages.GetStringFromName ("save_done");
    
    var ok = false;
    for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
      if (UnMHTSaveMulti.isSave (i)) {
        ok = 1;
        break;
      }
    }
    if (!ok) {
      return false;
    }
    
    UnMHTSaveMulti.acceptButton.disabled = true;
    UnMHTSaveMulti.cancelButton.disabled = false;
    
    UnMHTSaveMulti.defaultMode = -1;
    
    var base = document.getElementById ("base").value;
    base = escape (base);
    var prefBranch
    = Components.classes ["@mozilla.org/preferences-service;1"]
    .getService (Components.interfaces.nsIPrefBranch);
    prefBranch.setCharPref
    ("unmht.savemulti.base", base);
    
    UnMHTSaveMulti.progressCurrent.value = "";
    UnMHTSaveMulti.progressCurrentSize.value = "";
    UnMHTSaveMulti.progress.value = "0%";
    UnMHTSaveMulti.progressLabel.value
    = UnMHTSaveMulti.messages.GetStringFromName ("save_begin");
    UnMHTSaveMulti.failedLabel.hidden = true;
    UnMHTSaveMulti.failedLabel2.hidden = true;
    UnMHTSaveMulti.failedLabel3.hidden = true;
    UnMHTSaveMulti.failedList.hidden = true;
        
    UnMHTSaveMulti.additionalBox.selectedIndex = 1;
        
    UnMHTSaveMulti.ngList = new Array ();
        
    UnMHTSaveMulti.save ();
    
    return false;
  },

  /**
   * 戻るボタンのイベント
   */
  onBackButton : function () {
    UnMHTSaveMulti.acceptButton.disabled = false;
    UnMHTSaveMulti.cancelButton.disabled = false;
    UnMHTSaveMulti.additionalBox.selectedIndex = 0;
    UnMHTSaveMulti.cancelButton.label
    = UnMHTSaveMulti.messages.GetStringFromName ("savemulti_cancel");
  },
  
  /**
   * スキップボタンのイベント
   */
  onSkipButton : function () {
    if (UnMHTSaveMulti.saveContext != null) {
      UnMHTSaveMulti.saveContext.cancel ();
      
      UnMHTSaveMulti.done (true);
    }
  },
  
  /**
   * キャンセルが完了したイベント
   */
  onCancel : function () {
  },
  
  /**
   * 保存する
   */
  save : function () {
    var saveformat = document.getElementById ("saveformat").value;
    try {
      var prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch);
            
      prefBranch.setCharPref ("unmht.savemulti.lastformat", saveformat);
    }
    catch (e) {
    }
        
    var targetDocument;
    if (saveformat == "separated") {
      if (UnMHTSaveMulti.currentIndex
          >= UnMHTSaveMulti.targetDocuments.length) {
        UnMHTSaveMulti.doneAll ();
        return;
      }
        
      targetDocument
        = UnMHTSaveMulti.targetDocuments [UnMHTSaveMulti.currentIndex];
      
      if (!UnMHTSaveMulti.isSave (UnMHTSaveMulti.currentIndex)) {
        UnMHTSaveMulti.currentIndex ++;
        UnMHTSaveMulti.save ();
        return;
      }
            
      try {
        var title = targetDocument.title;
        if (title == "") {
          title = targetDocument.location.href;
        }
      }
      catch (e) {
        /* ドキュメントが閉じられた
         * 次へ */
        UnMHTSaveMulti.changeStatus (UnMHTSaveMulti.currentIndex, "x");
        
        UnMHTSaveMulti.currentIndex ++;
        UnMHTSaveMulti.save ();
        return;
      }
            
      UnMHTSaveMulti.changeStatus (UnMHTSaveMulti.currentIndex, "current");
    }
    else {
      if (document.getElementById ("filename_base").value == "") {
        /* ファイル名が空 */
        document.getElementById ("filename_base").focus ();
        UnMHTSaveMulti.additionalBox.selectedIndex = 0;
                
        return;
      }
      for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
        if (UnMHTSaveMulti.isSave (i)) {
          targetDocument = UnMHTSaveMulti.targetDocuments [i];
          break;
        }
      }
    }
        
    var savetype;
    savetype = document.getElementById ("savetype").value;
    try {
      var prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch);
            
      prefBranch.setCharPref ("unmht.savemulti.type", savetype);
    }
    catch (e) {
    }
    
    var useCurrentState = (savetype == "current");
    
    var file = UnMHTSaveMulti.getFile (targetDocument);
    if (file == null) {
      if (saveformat == "separated") {
        UnMHTSaveMulti.changeStatus (UnMHTSaveMulti.currentIndex, true);
      
        UnMHTSaveMulti.currentIndex ++;
        UnMHTSaveMulti.save ();
      }
      else {
        UnMHTSaveMulti.done ();
      }
      
      return;
    }
        
    if (saveformat == "separated") {
      try {
        UnMHTSaveMulti.saveContext = new UnMHTSaveContext ();
        UnMHTSaveMulti.skipButton.disabled = false;
                
        UnMHTSaveMulti.saveContext.init
        (file,
         targetDocument.location.href, targetDocument.title,
         UnMHTSaveMulti);
                
        UnMHTSaveMulti.saveContext.addDocument
        (targetDocument, useCurrentState,
         false, null,
         null,
         targetDocument.location.href, true, true);
        if (UnMHTSaveMulti.saveContext.isStopped) {
          return;
        }
      }
      catch (e) {
      }
    }
    else {
      var add_uris = [];
      var text = document.getElementById ("files").value;
      var lines = text.split (/[\r\n]/);
      for (var i = 0; i < lines.length; i ++) {
        if (lines [i]
            && lines [i].match (/^.+:\/\//)) {
          add_uris.push (lines [i]);
        }
      }
      
      var subject;
      var targetDocument = null;
      for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
        if (UnMHTSaveMulti.isSave (i)) {
          targetDocument = UnMHTSaveMulti.targetDocuments [i];
          break;
        }
      }
                
      subject = document.getElementById ("filename_base").value;
                
      UnMHTSaveMulti.saveContext = new UnMHTSaveContext ();
      UnMHTSaveMulti.skipButton.disabled = false;
                
      UnMHTSaveMulti.saveContext.init
      (file,
       targetDocument.location.href, subject,
       UnMHTSaveMulti);
            
      var content;
      content
      = "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n"
      + "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n"
      + "<html lang=\"ja\" xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">\n"
      + "<head>\n"
      + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n"
      + "<title>index</title>\n"
      + "</head>\n"
      + "<body>\n";
      + "<ul>\n";
            
      var locations = Object ();
      for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
        if (!UnMHTSaveMulti.isSave (i)) {
          UnMHTSaveMulti.changeStatus (i, "")
          continue;
        }
        try {
          var targetDocument
            = UnMHTSaveMulti.targetDocuments [i];
          
          var locationBase = targetDocument.location.href;
          var locationExt = "";
          if (locationBase.match (/^(.+)(\.[^\/\.]+)$/)) {
            locationBase = RegExp.$1;
            locationExt = RegExp.$2;
          }
          var location = locationBase + locationExt;
                    
          if (location in locations) {
            /* 同じ URI のタブがある場合 */
            if (useCurrentState) {
              /* 現在の状態を保存する場合には
               * 別々に保存する */
              var n = 1;
              while (location in locations) {
                n ++;
                location = locationBase + n + locationExt;
              }
              locations [location] = 1;
              UnMHTSaveMulti.saveContext.addDocument
                (targetDocument, useCurrentState,
                 false, null,
                 null,
                 location,
                 UnMHTSaveMulti.isHTML (targetDocument),
                 false);
              if (UnMHTSaveMulti.saveContext.isStopped) {
                return;
              }
            }
            else {
              /* 元のファイルを保存する場合には
               * 使い回す */
            }
          }
          else {
            locations [location] = 1;
                        
            UnMHTSaveMulti.saveContext.addDocument
              (targetDocument, useCurrentState,
               false, null,
               null,
               location,
               UnMHTSaveMulti.isHTML (targetDocument),
               false);
            if (UnMHTSaveMulti.saveContext.isStopped) {
              return;
            }
          }
                    
          var changetitle
            = (document.getElementById ("saveformat").value == "single"
               && document.getElementById ("changetitle").checked);
          
          var title = "", desc = "";
          if (changetitle) {
            title = UnMHTSaveMulti.getTitle (i);
            desc = UnMHTSaveMulti.getDesc (i);
          }
          else {
            title = targetDocument.title;
            if (title == "") {
              title = targetDocument.location.href;
            }
          }
          if (desc) {
            desc = "<div style=\"margin-left: 1em;\">" + UnMHTSave.conv.escapeEntity (desc) + "</div>";
          }
          
          content += 
            "<li><a class=\"unmht-tabs\" href=\""
            + UnMHTSave.conv.escapeEntity (location)
            + "\">"
            + UnMHTSave.conv.escapeEntity (title)
            + "</a>" + desc + "</li>\n";
                    
          UnMHTSaveMulti.changeStatus (i, "o")
        }
        catch (e) {
          /* ドキュメントが閉じられた
           * 次へ */
          UnMHTSaveMulti.changeStatus (i, "x")
        }
      }

      for (var i = 0; i < add_uris.length; i ++) {
          content += 
            "<li><a href=\""
            + UnMHTSave.conv.escapeEntity (add_uris [i])
            + "\">"
            + UnMHTSave.conv.escapeEntity (add_uris [i])
            + "</a></li>\n";
      }
            
      content
      += "</ul>\n"
      + "</body>\n"
      + "</html>\n";
            
      content = UnMHTSaveMulti.conv.convertFromUnicode (content, "UTF-8");
      
      if (saveformat == "single") {
        UnMHTSaveMulti.saveContext.addDataDocument
          (content, "index", "UTF-8", "text/html");
        
        UnMHTSaveMulti.saveContext.addExtraHeader
          ("X-UnMHT-tabs", "true");
      }
      
      for (var i = 0; i < add_uris.length; i ++) {
        UnMHTSaveMulti.saveContext.addFile
        (null, add_uris [i]);
      }
    }
        
    if (UnMHTSaveMulti.saveContext.files.length > 0) {
      UnMHTSaveMulti.saveContext.start ();
    }
  },
    
  /**
   * 保存失敗イベント
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  String type
   *         エラーの種類
   * @param  String desc
   *         エラーの詳細
   */
  onError : function (context, type, desc) {
    if (type == "save") {
      UnMHTSaveMulti.progressLabel.value
      = UnMHTSaveMulti.messages.GetStringFromName ("error_save");
    }
    else if (type == "open") {
      UnMHTSaveMulti.progressLabel.value
      = UnMHTSaveMulti.messages.GetStringFromName ("error_open");
    }
    else {
      UnMHTSaveMulti.progressCurrent.value = desc;
    }
    
    UnMHTSaveMulti.saveContext = null;
    UnMHTSaveMulti.skipButton.disabled = true;
  },
  
  /**
   * 進行状況変化イベント
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  String currentFile
   *         現在取得のファイル名
   * @param  Number currentSize
   *         取得したバイト数
   * @param  Number ok
   *         取得完了した数
   * @param  Number na
   *         取得中の数
   * @param  Number ng
   *         取得失敗した数
   */
  onProgress : function (context, currentFile, currentSize, ok, na, ng) {
    UnMHTSaveMulti.progressCurrent.value = currentFile;
    UnMHTSaveMulti.progressCurrentSize.value = currentSize;
        
    if (na > 0) {
      UnMHTSaveMulti.progressLabel.value
        = UnMHTSaveMulti.messages.GetStringFromName ("save_begin")
        + " " + (ok + ng) + "/" + (context.files.length);
      UnMHTSaveMulti.progress.setAttribute
        ("value",
         parseInt (ok * 100 / context.files.length) + "%");
    }
    else {
      UnMHTSaveMulti.progressLabel.value
      = UnMHTSaveMulti.messages.GetStringFromName ("save_begin")
      + " " + (ok + ng) + "/" + (context.files.length);
      UnMHTSaveMulti.progress.setAttribute ("value", "100%");
    }
  },
    
  /**
   * 保存完了
   *
   * @param  UnMHTSaveContext context
   *         対象の保存コンテキスト
   * @param  Array ngList
   *         失敗したファイル
   *           [String ファイル名, ...]
   */
  onSave : function (context, ngList) {
    UnMHTSaveMulti.progressLabel.value
    = UnMHTSaveMulti.messages.GetStringFromName ("save_done");
    
    for (var i = 0; i < ngList.length; i ++) {
      UnMHTSaveMulti.ngList.push (ngList [i]);
    }
        
    UnMHTSaveMulti.done (false);
  },
  
  lastSingleFilename : "",
  
  /**
   * 単一のファイルのファイル名を更新する
   */
  updateSingleFilename : function () {
    var base = document.getElementById ("filename_base");
    if (UnMHTSaveMulti.lastSingleFilename != ""
        && base.value != UnMHTSaveMulti.lastSingleFilename
        && base.value != "") {
      return;
    }
    if (document.getElementById ("saveformat").value == "single"
        || document.getElementById ("saveformat").value == "single_noindex") {
      var filename = "";
      for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
        if (UnMHTSaveMulti.isSave (i)) {
          filename
            = UnMHTSaveMulti.getFilename
            (UnMHTSaveMulti.targetDocuments [i]);
          break;
        }
      }
            
      base.value = filename;
      UnMHTSaveMulti.lastSingleFilename = filename;
    }
  },

  /**
   * 保存先のファイルを返す
   *
   * @param  HTMLDocument targetDocument
   *         対象のドキュメント
   */
  getFile : function (targetDocument) {
    var base = document.getElementById ("base").value;
    var filename;
    if (document.getElementById ("saveformat").value == "single"
        || document.getElementById ("saveformat").value == "single_noindex") {
      filename = document.getElementById ("filename_base").value;
      filename = UnMHTFormatter.validateFileName (filename);
    }
    else if (document.getElementById ("filename").value == "leafname"
             || document.getElementById ("filename").value == "title"
             || document.getElementById ("filename").value == "custom") {
      filename = UnMHTSaveMulti.getFilename (targetDocument);
    }
    else if (document.getElementById ("filename").value == "sequential") {
      filename = document.getElementById ("filename_base").value;
      filename = UnMHTFormatter.validateFileName (filename);
      filename += "-" + (UnMHTSaveMulti.currentIndex + 1);
    }
    var filenameBase = filename;
    filename += ".mht";
    
    var message
    = UnMHTSaveMulti.messages.GetStringFromName ("illegal_directory");
    var file
    = Components.classes ["@mozilla.org/file/local;1"]
    .createInstance (Components.interfaces.nsILocalFile);
    try {
      file.initWithPath (base);
      
      if (!file.exists ()) {
        file.create (Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
      }
    }
    catch (e) {
      /* ディレクトリが不正 */
      UnMHTSaveMulti.acceptButton.disabled = false;
      
      UnMHTSaveMulti.failedLabel.value = message;
      UnMHTSaveMulti.failedLabel.hidden = false;
      
      document.getElementById ("saved_label").value
      = UnMHTSaveMulti.messages.GetStringFromName ("savemulti_failed");
      
      return null;
    }
    file.appendRelativePath (filename);
        
    if (file.exists ()) {
      var result = {
        result : 0,
        applyToAll: false,
        rename : false,
        filename : ""
      };
            
      if (UnMHTSaveMulti.enableAutoReplace) {
        UnMHTSaveMulti.defaultMode
          = UnMHTSaveMulti.autoReplaceAction;
      }
            
      if (UnMHTSaveMulti.defaultMode == -1) {
        var filename2 = filename;
        var i
          = UnMHTSaveMulti.config.initPref ("int", "unmht.save.dup.init", 2);
        var file2
          = Components.classes ["@mozilla.org/file/local;1"]
          .createInstance (Components.interfaces.nsILocalFile);
        file2.initWithPath (base);
        file2.appendRelativePath (filename2);
        while (file2.exists ()) {
          filename2 = filenameBase + "-" + UnMHTSaveMulti.padDup (i) + ".mht";
          file2
            = Components.classes ["@mozilla.org/file/local;1"]
            .createInstance (Components.interfaces.nsILocalFile);
          file2.initWithPath (base);
          file2.appendRelativePath (filename2);
          i ++;
        }
                
        var confirmURL = "chrome://unmht/content/confirm.xul";
        var features = "chrome,dialog,modal,centerscreen";
        var m = UnMHTSaveMulti.messages;
        var mtime = new Date ();
        mtime.setTime (file.lastModifiedTime);
        var param = {
          result: result,
          title: m.GetStringFromName ("overwrite_title"),
          message1: m.GetStringFromName ("overwrite_pre")
          + " " + filename + " "
          + m.GetStringFromName ("overwrite_post"),
          message2: m.GetStringFromName ("overwrite_lastaccess")
          + " " + mtime,
          message3: m.GetStringFromName ("overwrite_post2"),
          accept: m.GetStringFromName ("replace"),
          extra1: m.GetStringFromName ("skip"),
          extra2: m.GetStringFromName ("abort"),
          rename: m.GetStringFromName ("rename"),
          toall: m.GetStringFromName ("overwrite_all"),
          filename: filename2,
          base: base,
          exist1: m.GetStringFromName ("overwrite_pre"),
          exist2: m.GetStringFromName ("overwrite_post")
        };
        openDialog (confirmURL, "", features, param);
        if (result.applyToAll) {
          UnMHTSaveMulti.defaultMode = result.result;
        }
      }
      else {
        result.result = UnMHTSaveMulti.defaultMode;
        if (result.result == "rename") {
          var i
            = UnMHTSaveMulti.config.initPref ("int", "unmht.save.dup.init", 2);
          var file
            = Components.classes ["@mozilla.org/file/local;1"]
            .createInstance (Components.interfaces.nsILocalFile);
          file.initWithPath (base);
          file.appendRelativePath (filename);
          while (file.exists ()) {
            filename = filenameBase + "-" + UnMHTSaveMulti.padDup (i) + ".mht";
            var file
              = Components.classes ["@mozilla.org/file/local;1"]
              .createInstance
              (Components.interfaces.nsILocalFile);
            file.initWithPath (base);
            file.appendRelativePath (filename);
            i ++;
          }
          result.filename = filename;
        }
      }
            
      if (result.result == "rename") {
        filename = result.filename;
        var file
          = Components.classes ["@mozilla.org/file/local;1"]
          .createInstance (Components.interfaces.nsILocalFile);
        file.initWithPath (base);
        file.appendRelativePath (filename);
      }
            
      if (result.result == "skip") {
        return null;
      }
      else if (result.result == "abort" || result.result == "no") {
        return null;
      }
    }
        
    return file;
  },
    
  /**
   * 保存完了イベント
   *
   * @param  Boolean skipped
   *         スキップされたか
   */
  done : function (skipped) {
    if (document.getElementById ("saveformat").value == "separated") {
      var targetDocument
      = UnMHTSaveMulti.targetDocuments [UnMHTSaveMulti.currentIndex]
      var title = targetDocument.title;
      if (title == "") {
        title = targetDocument.location.href;
      }
      
      if (skipped) {
        UnMHTSaveMulti.changeStatus (UnMHTSaveMulti.currentIndex, "x")
      }
      else {
        UnMHTSaveMulti.changeStatus (UnMHTSaveMulti.currentIndex, "o")
      }
      
      UnMHTSaveMulti.currentIndex ++;
      UnMHTSaveMulti.save ();
    }
    else {
      UnMHTSaveMulti.doneAll ();
    }
  },
  
  /**
   * 全ファイル保存完了イベント
   */
  doneAll : function () {
    UnMHTSaveMulti.acceptButton.disabled = true;
    UnMHTSaveMulti.cancelButton.disabled = false;
    UnMHTSaveMulti.cancelButton.label
    = UnMHTSaveMulti.messages.GetStringFromName ("savemulti_close");
    UnMHTSaveMulti.saveContext = null;
    
    UnMHTSaveMulti.currentIndex = 0;
    UnMHTSaveMulti.additionalBox.selectedIndex = 2;
    
    if (UnMHTSaveMulti.enableShowErrors
        && UnMHTSaveMulti.ngList.length > 0) {
      var s = "";
      for (var i = 0; i < UnMHTSaveMulti.ngList.length; i ++) {
        s += UnMHTSaveMulti.ngList [i] + "\n";
      }
      UnMHTSaveMulti.failedList.value = s;
      UnMHTSaveMulti.failedList.hidden = false;
      if (UnMHTSaveMulti.failedLabel
          && UnMHTSaveMulti.failedLabel.value != "") {
        UnMHTSaveMulti.failedLabel.hidden = false;
      }
      if (UnMHTSaveMulti.failedLabel2
          && UnMHTSaveMulti.failedLabel2.value != "") {
        UnMHTSaveMulti.failedLabel2.hidden = false;
      }
      if (UnMHTSaveMulti.failedLabel3
          && UnMHTSaveMulti.failedLabel3.value != "") {
        UnMHTSaveMulti.failedLabel3.hidden = false;
      }
      window.sizeToContent ();
    }
        
    if (UnMHTSaveMulti.enableAutoClose) {
      setTimeout (function (window) {
          window.close ();
        }, 1000, window);
    }
  },
    
  /**
   * 全てを選択/解除する
   */
  checkAllNone : function () {
    if (UnMHTSaveMulti.targetDocuments.length == 0) {
      return;
    }
    
    var first = UnMHTSaveMulti.isSave (0);

    for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
      UnMHTSaveMulti.changeSave (i, !first);
    }
    
    UnMHTSaveMulti.updateCount ();
    UnMHTSaveMulti.updateSingleFilename ();
  },
  
  /**
   * 対象を変更したイベント
   */
  changeTarget : function () {
    var targetWindows = new Array ();
        
    if (document.getElementById ("target").value == "this") {
      targetWindows.push (UnMHTSaveMulti.targetWindow);
    }
    else {
      var entries
      = Components.classes ["@mozilla.org/appshell/window-mediator;1"]
      .getService (Components.interfaces.nsIWindowMediator)
      .getEnumerator ("navigator:browser");
            
      while (entries.hasMoreElements ()) {
        targetWindows.push (entries.getNext ());
      }
    }
    
    UnMHTSaveMulti.clearList ();
    
    UnMHTSaveMulti.targetDocuments = new Array ();
        
    var asSingle;
        
    asSingle = (document.getElementById ("saveformat").value == "single"
                || document.getElementById ("saveformat").value
                == "single_noindex");
    for (var i = 0; i < targetWindows.length; i ++) {
      var w = targetWindows [i];
            
      var tabbrowser = w.document.getElementById ("content");
      if (!tabbrowser) {
        tabbrowser = w.document.getElementById ("browser_content");
      }
      
      if ("visibleTabs" in tabbrowser) {
        for (var j = 0; j < tabbrowser.visibleTabs.length; j ++) {
          var b = tabbrowser.getBrowserForTab (tabbrowser.visibleTabs [j]);
          var targetDocument
            = b.contentDocument;
          if (UnMHTSaveMulti.isSavable (targetDocument, asSingle)) {
            UnMHTSaveMulti.targetDocuments.push (targetDocument);
          }
        }
      }
      else if ("browsers" in tabbrowser) {
        for (var j = 0; j < tabbrowser.browsers.length; j ++) {
          var targetDocument
            = tabbrowser.browsers [j].contentDocument;
          if (UnMHTSaveMulti.isSavable (targetDocument, asSingle)) {
            UnMHTSaveMulti.targetDocuments.push (targetDocument);
          }
        }
      }
      else {
        var targetDocument = tabbrowser.contentDocument;
        if (UnMHTSaveMulti.isSavable (targetDocument, asSingle)) {
          UnMHTSaveMulti.targetDocuments.push (targetDocument);
        }
      }
    }
        
    for (var j = 0; j < UnMHTSaveMulti.targetDocuments.length; j ++) {
      var targetDocument = UnMHTSaveMulti.targetDocuments [j];
                
      var title = targetDocument.title;
      if (title == "") {
        title = targetDocument.location.href;
      }
      
      UnMHTSaveMulti.addItem (j, title);
    }
    UnMHTSaveMulti.updateCount ();
  },
  
  /**
   * 選択している数を更新したイベント
   */
  updateCount : function () {
    var count = 0;
    for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
      if (UnMHTSaveMulti.isSave (i)) {
        count ++;
      }
    }
    
    document.getElementById ("count_label").value
    = count + "/" + UnMHTSaveMulti.targetDocuments.length;
  },
    
  /**
   * ファイル名を変更したイベント
   */
  changeFilename : function () {
    document.getElementById ("filename_base").disabled
    = (document.getElementById ("filename").value != "sequential"
       && document.getElementById ("saveformat").value != "single"
       && document.getElementById ("saveformat").value != "single_noindex");
    
    var base = document.getElementById ("filename_base");
    if (document.getElementById ("filename").value == "sequential") {
      base.setAttribute ("placeholder",
                         UnMHTSaveMulti.messages.GetStringFromName ("savemulti_sequential_placeholder"));
      base.value = "";
    }
    else {
      base.setAttribute ("placeholder", "");
    }
  },
    
  /**
   * タイトルを変更するかどうかを変更したイベント
   */
  changeTitle : function () {
    for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
      UnMHTSaveMulti.updateHidden (i);
    }
    
    var hidden
    = (document.getElementById ("saveformat").value != "single"
       || !document.getElementById ("changetitle").checked);
    
    document.getElementById ("target_list_desc").hidden = hidden;
  },
  
  /**
   * ファイルのURIを追加をチェックしたイベント
   */
  changeAddFiles : function () {
    var hidden = !document.getElementById ("add_files").checked;
    document.getElementById ("files").hidden
    = hidden;
    window.sizeToContent ();
  },
  
  /**
   * 形式を変更したイベント
   */
  changeFormat : function () {
    UnMHTSaveMulti.changeTitle ();
    
    document.getElementById ("changetitle").disabled
    = (document.getElementById ("saveformat").value != "single");
    
    document.getElementById ("add_files").disabled
    = (document.getElementById ("saveformat").value == "separated");

    document.getElementById ("filename").disabled
    = (document.getElementById ("saveformat").value != "separated");
        
    document.getElementById ("files").disabled
    = (document.getElementById ("saveformat").value != "single"
       && document.getElementById ("saveformat").value != "single_noindex");
    
    if (document.getElementById ("saveformat").value == "separated") {
      document.getElementById ("add_files").checked = false;
      UnMHTSaveMulti.changeAddFiles ();
      
      UnMHTSaveMulti.lastSingleFilename = "";
    }
        
    UnMHTSaveMulti.changeFilename ();
    UnMHTSaveMulti.changeTarget ();
    UnMHTSaveMulti.updateSingleFilename ();
    
    if (document.getElementById ("saveformat").value == "single"
        || document.getElementById ("saveformat").value == "single_noindex") {
      document.getElementById ("filename_base").focus ();
      document.getElementById ("filename_base").select ();
    }
  },
    
  lastDragSave : false,   /* String ドラッグ開始した項目の選択の種類 */
  lastDragNode : null, /* XULElement ドラッグ開始した項目 */
    
  /**
   * 保存対象の項目を押したイベント
   *
   * @param  XULElement checkNode
   *         対象の要素
   */
  onMouseDownCheck : function (checkNode) {
    var save = UnMHTSaveMulti.isSaveNode (checkNode);
    
    UnMHTSaveMulti.lastDragType = save;
    UnMHTSaveMulti.lastDragNode = checkNode;
    
    UnMHTSaveMulti.changeSaveNode (checkNode, !save);
    
    UnMHTSaveMulti.updateCount ();
    UnMHTSaveMulti.updateSingleFilename ();
  },
    
  /**
   * マウスを動かしたイベント
   * リストボックス上のドラッグでチェックを変更する
   *
   * @param  XULElement checkNode
   *         対象の要素
   */
  onMouseMoveCheck : function (checkNode) {
    if (UnMHTSaveMulti.lastDragNode == null) {
      return;
    }
    
    if (UnMHTSaveMulti.lastDragNode == checkNode) {
      return;
    }
    
    UnMHTSaveMulti.changeSaveNode (checkNode, !UnMHTSaveMulti.lastDragType);
    
    UnMHTSaveMulti.updateCount ();
    UnMHTSaveMulti.updateSingleFilename ();
  },
    
  /**
   * マウスが出たイベント
   * リストボックスのドラッグを終了する
   *
   * @param  Event event
   *         対象のイベント
   */
  onMouseOut : function (event) {
    if (event.explicitOriginalTarget == UnMHTSaveMulti.dialog) {
      UnMHTSaveMulti.lastDragNode = null;
    }
  },
    
  /**
   * マウスのボタンを開放したイベント
   * リストボックスのドラッグを終了する
   *
   * @param  Event event
   *         対象のイベント
   */
  onMouseUp : function (event) {
    UnMHTSaveMulti.lastDragNode = null;
  },
    
  /**
   * ファイル、ディレクトリを選択する
   */
  selectBase : function () {
    var filePicker
    = Components.classes ["@mozilla.org/filepicker;1"]
    .createInstance (Components.interfaces.nsIFilePicker);
    var flag = Components.interfaces.nsIFilePicker.modeGetFolder;
        
    filePicker.init (window, "", flag);
        
    try {
      var base = document.getElementById ("base").value;
            
      var dir
        = Components.classes ["@mozilla.org/file/local;1"]
        .createInstance (Components.interfaces.nsILocalFile);
      dir.initWithPath (base);
            
      filePicker.displayDirectory = dir;
    }
    catch (e) {
    }
        
    if (filePicker.show ()
        == Components.interfaces.nsIFilePicker.returnOK) {
      document.getElementById ("base").value
      = filePicker.file
      .QueryInterface (Components.interfaces.nsILocalFile).path;
    }
  },
    
  /**
   * メニュー, ラヂオボタンの選択肢を表示に反映する
   * (古いバージョンだと value の変更だけでは反映されない)
   *
   */
  selectItem : function (node) {
    var value = node.value;
        
    var nodes = node.getElementsByTagName ("radio");
    for (var i = 0; i < nodes.length; i ++) {
      if (nodes [i].value == value) {
        node.selectedItem = nodes [i];
      }
    }
  },
  
  /**
   * 保存可能かどうかを調べる
   *
   * @param  HTMLDocument targetDocument
   *         対象のドキュメント
   * @param  Boolean asSingle
   *         単一のファイルとして保存するかどうか
   * @return Boolean
   *         保存可能かどうか
   */
  isSavable : function (targetDocument, asSingle) {
    if (targetDocument.contentType.match (/^text/)
             || targetDocument.contentType.match (/\/x(ht)?ml$/)) {
      return true;
    }
    else if (asSingle) {
      return true;
    }
    else {
      return false;
    }
  },
    
  /**
   * HTML かどうかを調べる
   *
   * @param  HTMLDocument targetDocument
   *         対象のドキュメント
   * @return Boolean
   *         HTML かどうか
   */
  isHTML : function (targetDocument) {
    if (targetDocument.contentType.match (/^text/)
        || targetDocument.contentType.match (/\/x(ht)?ml$/)) {
      return true;
    }
    else {
      return false;
    }
  },
    
  /**
   * 保存する際のファイル名を取得する
   *
   * @param  HTMLDocument targetDocument
   *         対象のドキュメント
   */
  getFilename : function (targetDocument) {
    var filename;
    var title, uri;
        
    filename = "";
        
    try {
      uri = targetDocument.location.href;
      title = targetDocument.title;
    }
    catch (e) {
      return null;
    }
        
    if (uri.match (/[^\?]+\/([^\/\?]+)(\?.+)?(#.+)?$/)) {
      filename = RegExp.$1;
      if (filename.match (/^(.+)\.[^\.]+$/)) {
        filename = RegExp.$1;
      }
      else {
        filename = filename;
      }
    }
    else {
      filename = "index";
    }
        
    if (document.getElementById ("filename").value == "title") {
      var tmp = UnMHTSaveMulti.validateFileName (title);
            
      if (tmp) {
        filename = tmp;
      }
    }
    else if (document.getElementById ("filename").value == "custom") {
      var pattern = UnMHTSaveMulti.saveFilenameCustom;
      var am = UnMHTSaveMulti.saveFilenameCustomAM;
      var pm = UnMHTSaveMulti.saveFilenameCustomPM;
            
      filename
      = UnMHTFormatter.format (pattern, title, filename, uri, am, pm);
    }
    else {
      filename = UnMHTFormatter.validateFileName (filename);
    }
        
    return filename;
  },
    
  /**
   * ファイル名に使えない文字を変換する
   *
   * @param  String filename
   *         元のファイル名
   * @return String
   *         変換したファイル名
   */
  validateFileName : function (filename) {
    var re = /[\/]+/g;
    if (navigator.appVersion.indexOf ("Windows") != -1) {
      re = /[\\\/\|]+/g;
      filename = filename.replace (/[\"]+/g, "'")
        .replace (/[\*\:\?]+/g, " ")
        .replace (/[\<]+/g, "(")
        .replace (/[\>]+/g, ")");
    }
    else if (navigator.appVersion.indexOf ("Macintosh") != -1) {
      re = /[\:\/]+/g;
    }
        
    filename = filename.replace (re, "_");
        
    return filename;
  },
  
  padDup : function (n) {
    var s = n + "";
    
    while (s.length < UnMHTSaveMulti.dupDigits) {
      s = "0" + s;
    }
    
    return s;
  },
  
  getTitle : function (index) {
    var node = document.getElementById ("savetitle_" + index);
    return node.getAttribute ("label");
  },

  getDesc : function (index) {
    var node = document.getElementById ("savedesc_" + index);
    return node.getAttribute ("label");
  },
  
  isSave : function (index) {
    var node = document.getElementById ("savecheck_" + index);
    return UnMHTSaveMulti.isSaveNode (node);
  },

  isSaveNode : function (node) {
    return node.getAttribute ("value") == "save";
  },
  
  changeSave : function (index, save) {
    var node = document.getElementById ("savecheck_" + index);
    return UnMHTSaveMulti.changeSaveNode (node, save);
  },
  
  changeSaveNode : function (node, save) {
    if (save) {
      node.setAttribute ("value", "save");
      node.setAttribute ("src", "chrome://unmht/content/check_v.png");
    }
    else {
      node.setAttribute ("value", "ignore");
      node.setAttribute ("src", "chrome://unmht/content/check_dot.png");
    }
  },
  
  changeStatus : function (index, status) {
    var node = document.getElementById ("savestatus_" + index);
    return UnMHTSaveMulti.changeStatusNode (node, status);
  },
  
  changeStatusNode : function (node, status) {
    if (status) {
      node.setAttribute ("src",
                         "chrome://unmht/content/check_" + status + ".png");
    }
    else {
      node.setAttribute ("src", "");
    }
  },
  
  clearList : function () {
    var listbox = document.getElementById ("target_list_children");
    while (listbox.firstChild) {
      listbox.removeChild (listbox.firstChild);
    }
  },
  
  getCheckNode : function (event) {
    var tree = document.getElementById ("target_list");
    var tbo = tree.treeBoxObject;

    var row = {}, col = {}, child = {};
    tbo.getCellAt (event.clientX, event.clientY, row, col, child);    
    
    if (row.value == -1) {
      return null;
    }
    
    if (col.value == null) {
      return null;
    }
    
    if (col.value.index != 0) {
      return null;
    }
    
    var listbox = document.getElementById ("target_list_children");
    
    return listbox.childNodes [row.value].firstChild.firstChild;
  },
  
  onTreeMouseMove : function (event) {
    var checkNode = UnMHTSaveMulti.getCheckNode (event);
    if (!checkNode) {
      return;
    }
    
    UnMHTSaveMulti.onMouseMoveCheck (checkNode);
  },
  
  onTreeMouseDown : function (event) {
    var checkNode = UnMHTSaveMulti.getCheckNode (event);
    if (!checkNode) {
      return;
    }
    
    UnMHTSaveMulti.onMouseDownCheck (checkNode);
  },


  addItem : function (index, title) {
    var listbox = document.getElementById ("target_list_children");
    
    var listitem = document.createElement ("treeitem");
    listbox.appendChild (listitem);
    
    var listrow = document.createElement ("treerow");
    listitem.appendChild (listrow);
    
    var checkNode = document.createElement ("treecell");
    listrow.appendChild (checkNode);
    checkNode.id = "savecheck_" + index;
    checkNode.className = "save-iconic";
    checkNode.setAttribute ("editable", "false");
    UnMHTSaveMulti.changeSaveNode (checkNode, !UnMHTSaveMulti.enableNone);

    var statusNode = document.createElement ("treecell");
    listrow.appendChild (statusNode);
    statusNode.id = "savestatus_" + index;
    statusNode.setAttribute ("editable", "false");
    statusNode.className = "save-iconic";
    
    var titleNode = document.createElement ("treecell");
    listrow.appendChild (titleNode);
    titleNode.id = "savetitle_" + index;
    titleNode.setAttribute ("editable", "true");
    titleNode.setAttribute ("label", title);
    titleNode.flex = 1;

    var descNode = document.createElement ("treecell");
    listrow.appendChild (descNode);
    descNode.id = "savedesc_" + index;
    descNode.setAttribute ("editable", "true");
    descNode.flex = 1;
    
    UnMHTSaveMulti.updateHidden (index);
  },
  
  updateHidden : function (index) {
    var hidden
    = (document.getElementById ("saveformat").value != "single"
       || !document.getElementById ("changetitle").checked);
    
    document.getElementById ("savetitle_" + index)
    .setAttribute ("editable", !hidden);
    document.getElementById ("savedesc_" + index)
    .setAttribute ("editable", !hidden);
    
    document.getElementById ("savedesc_" + index).hidden = hidden;
  }
};
