/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/**
 * 保存オプション
 */
var UnMHTSaveOptions = {
  param : null,
  
  /**
   * 初期化処理
   */
  init : function () {
    UnMHTSaveOptions.arg = window.arguments [0];
    
    if (Components.interfaces.nsIPrefBranch2) {
      UnMHTSaveOptions.prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch2);
    }
    else {
      UnMHTSaveOptions.prefBranch
      = Components.classes ["@mozilla.org/preferences-service;1"]
      .getService (Components.interfaces.nsIPrefBranch);
    }
    
    if (UnMHTSaveOptions.arg.showFilename) {
      document.getElementById ("filename").value
      = UnMHTSaveOptions.arg.filename;
    }
    else {
      document.getElementById ("filename_box").hidden = true;
    }
    
    document.getElementById ("savetype").value
    = UnMHTSaveOptions
    .initPref ("char", "unmht.save.savetype.default", "current");
    
    if (!UnMHTSaveOptions.arg.enableCurrent) {
      document.getElementById ("savetype_current").hidden = true;
      document.getElementById ("savetype").value = "original";
    }
    if (!UnMHTSaveOptions.arg.enableOriginal) {
      document.getElementById ("savetype_original").hidden = true;
      document.getElementById ("savetype").value = "current";
    }
    
    UnMHTSaveOptions.selectItem (document.getElementById
                                 ("savetype"));
    
    document.getElementById ("save_insertlink").checked
    = UnMHTSaveOptions
    .initPref ("bool", "unmht.save.insertlink", false);
  },
    
  /**
   * メニュー, ラヂオボタンの選択肢を表示に反映する
   * (古いバージョンだと value の変更だけでは反映されない)
   *
   */
  selectItem : function (node) {
    var value = node.value;
        
    var nodes = node.getElementsByTagName ("radio");
    for (var i = 0; i < nodes.length; i ++) {
      if (nodes [i].value == value) {
        node.selectedItem = nodes [i];
      }
    }
  },
  
  /**
   * 設定を読み込む
   * 設定が無ければ既定値を書き込む
   *
   * @param  String type
   *         設定の種類
   *          "bool"
   *          "char"
   *          "int"
   * @param  String name
   *         設定名
   * @param  Boolean/String/Number value
   *         既定値
   * @return Boolean/String/Number
   *         取得した値
   *         設定が無ければ既定値
   */
  initPref : function (type, name, value) {
    if (UnMHTSaveOptions.prefBranch.prefHasUserValue (name)) {
      ; /* switch のインデント用 */
      switch (type) {
        case "bool":
          value = UnMHTSaveOptions.prefBranch.getBoolPref (name);
          break;
        case "char":
          value = UnMHTSaveOptions.prefBranch.getCharPref (name);
          break;
        case "int":
          value = UnMHTSaveOptions.prefBranch.getIntPref (name);
          break;
      }
    }
    else {
      ; /* switch のインデント用 */
      switch (type) {
        case "bool":
          UnMHTSaveOptions.prefBranch.setBoolPref (name, value);
          break;
        case "char":
          UnMHTSaveOptions.prefBranch.setCharPref (name, value);
          break;
        case "int":
          UnMHTSaveOptions.prefBranch.setIntPref (name, value);
          break;
      }
    }
    
    return value;
  },
  
  /**
   * 設定を保存する
   *
   * @param  String type
   *         設定の種類
   *          "bool"
   *          "char"
   *          "int"
   * @param  String name
   *         設定名
   * @param  Boolean/String/Number value
   *         既定値
   */
  setPref : function (type, name, value) {
    ; /* switch のインデント用 */
    switch (type) {
      case "bool":
        UnMHTSaveOptions.prefBranch.setBoolPref (name, value);
        break;
      case "char":
        UnMHTSaveOptions.prefBranch.setCharPref (name, value);
        break;
      case "int":
        UnMHTSaveOptions.prefBranch.setIntPref (name, value);
        break;
    }
  },
  
  /**
   * 保存ボタンを押したイベント
   */
  onAccept : function () {
    var param = new Object ();
    
    UnMHTSaveOptions
    .setPref ("char", "unmht.save.savetype.default",
              document.getElementById ("savetype").value);
    
    UnMHTSaveOptions
    .setPref ("bool", "unmht.save.insertlink",
              document.getElementById ("save_insertlink").checked);
    
    if (UnMHTSaveOptions.arg.showFilename) {
      param.targetFilename
        = document.getElementById ("filename").value;
    }

    param.useCurrentState
    = (document.getElementById ("savetype").value == "current");
    param.additionalFiles = new Array ();
    var text = document.getElementById ("files").value;
    var lines = text.split (/[\r\n]/);
    for (var i = 0; i < lines.length; i ++) {
      if (lines [i]
          && lines [i].match (/^.+:\/\//)) {
        param.additionalFiles.push (lines [i]);
      }
    }
    
    param.enableInsertLink
    = document.getElementById ("save_insertlink").checked;
    
    if ("callback" in UnMHTSaveOptions.arg) {
      var f = {
        callback : UnMHTSaveOptions.arg.callback,
        param : param,
        
        /**
         * インターフェースの要求
         *   nsISupports.QueryInterface
         *
         * @param  nsIIDRef iid
         *         インターフェース ID
         * @throws Components.results.NS_NOINTERFACE
         * @return nsIStreamListener
         *         this
         */
        QueryInterface : function (iid) {
          if (iid.equals (nsISupports)
              || iid.equals (nsITimerCallback)) {
            return this;
          }
        
          throw Components.results.NS_ERROR_NO_INTERFACE;
        },
        /**
         * 時間経過イベント
         *   nsITimerCallback.notify
         *
         * @param  nsITimer timer
         *         呼び出し元のタイマ
         */
        notify : function (timer) {
          this.callback (this.param);
        }
      };
      
      var timer
      = Components.classes ["@mozilla.org/timer;1"]
      .createInstance (Components.interfaces.nsITimer);
      timer.initWithCallback
      (f,
       100,
       Components.interfaces.nsITimer.TYPE_ONESHOT);
    }
    
    return true;
  },
  
  /**
   * キャンセルボタンを押したイベント
   */
  onCancel : function () {
    return true;
  }
};
